diff -uwr sourceold/scripts/engine_script.cpp source/scripts/engine_script.cpp
--- sourceold/scripts/engine_script.cpp	2011-10-11 23:03:17.410156200 +0800
+++ source/scripts/engine_script.cpp	2012-04-29 00:21:50.067382800 +0800
@@ -16,18 +16,20 @@
 #include "slist.h"
 #include "GameObjManager.h"
 #include "engine_obj.h"
+#include "engine_obj2.h"
 #include "engine_def.h"
 #include "Definition.h"
 #include "engine_phys.h"
 #include "engine_game.h"
 #include "BuildingGameObj.h"
+#include "VehicleGameObj.h"
 SCRIPTS_API void Remove_Script(GameObject *obj,const char *script)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	const SimpleDynVecClass<GameObjObserverClass *> *observers = &((ScriptableGameObj *)obj)->Get_Observers();
+	const SimpleDynVecClass<GameObjObserverClass *> *observers = &obj->Get_Observers();
 	int x = observers->Count();
 	for (int i = 0;i < x;i++)
 	{
@@ -40,11 +42,11 @@
 
 SCRIPTS_API void Remove_Duplicate_Script(GameObject *obj, const char *script)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	const SimpleDynVecClass<GameObjObserverClass *> *observers = &((ScriptableGameObj *)obj)->Get_Observers();
+	const SimpleDynVecClass<GameObjObserverClass *> *observers = &obj->Get_Observers();
 	bool Found = false;
 	for (int i = 0;i < observers->Count();i++)
 	{
@@ -67,15 +69,20 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			const DefinitionClass *d = Get_Definition(o);
+			const DefinitionClass *d = &o2->Get_Definition();
 			if (!_stricmp(d->Get_Name(),preset))
 			{
-				if ((Get_Object_Type(o) == team) || (team == 2))
+				if ((Get_Object_Type(o2) == team) || (team == 2))
 				{
-					Remove_Script(o,script);
+					Remove_Script(o2,script);
 				}
 			}
 		}
@@ -88,15 +95,20 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
 		{
-			const DefinitionClass *d = Get_Definition(o);
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
+		{
+			const DefinitionClass *d = &o2->Get_Definition();
 			if (d->Get_Class_ID() == type)
 			{
-				if ((Get_Object_Type(o) == team) || (team == 2))
+				if ((Get_Object_Type(o2) == team) || (team == 2))
 				{
-					Remove_Script(o,script);
+					Remove_Script(o2,script);
 				}
 			}
 		}
@@ -106,11 +118,11 @@
 
 SCRIPTS_API void Remove_All_Scripts(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	const SimpleDynVecClass<GameObjObserverClass *> *observers = &((ScriptableGameObj *)obj)->Get_Observers();
+	const SimpleDynVecClass<GameObjObserverClass *> *observers = &obj->Get_Observers();
 	int x = observers->Count();
 	for (int i = 0;i < x;i++)
 	{
@@ -126,15 +138,20 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			const DefinitionClass *d = Get_Definition(o);
+			const DefinitionClass *d = &o2->Get_Definition();
 			if (!_stricmp(d->Get_Name(),preset))
 			{
-				if ((Get_Object_Type(o) == team) || (team == 2))
+				if ((Get_Object_Type(o2) == team) || (team == 2))
 				{
-					Commands->Attach_Script(o,script,params);
+					Commands->Attach_Script(o2,script,params);
 				}
 			}
 		}
@@ -147,15 +164,20 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
 		{
-			const DefinitionClass *d = Get_Definition(o);
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
+		{
+			const DefinitionClass *d = &o2->Get_Definition();
 			if (d->Get_Class_ID() == type)
 			{
-				if ((Get_Object_Type(o) == team) || (team == 2))
+				if ((Get_Object_Type(o2) == team) || (team == 2))
 				{
-					Commands->Attach_Script(o,script,params);
+					Commands->Attach_Script(o2,script,params);
 				}
 			}
 		}
@@ -165,11 +187,11 @@
 
 SCRIPTS_API bool Is_Script_Attached(GameObject *obj,const char *script)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return false;
 	}
-	const SimpleDynVecClass<GameObjObserverClass *> *observers = &((ScriptableGameObj *)obj)->Get_Observers();
+	const SimpleDynVecClass<GameObjObserverClass *> *observers = &obj->Get_Observers();
 	int x = observers->Count();
 	for (int i = 0;i < x;i++)
 	{
@@ -183,7 +205,7 @@
 
 SCRIPTS_API void Attach_Script_Once(GameObject *obj,const char *script,const char *params)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
@@ -198,17 +220,22 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			const DefinitionClass *d = Get_Definition(o);
+			const DefinitionClass *d = &o2->Get_Definition();
 			if (!_stricmp(d->Get_Name(),preset))
 			{
-				if ((Get_Object_Type(o) == team) || (team == 2))
+				if ((Get_Object_Type(o2) == team) || (team == 2))
 				{
-					if (!Is_Script_Attached(o,script))
+					if (!Is_Script_Attached(o2,script))
 					{
-						Commands->Attach_Script(o,script,params);
+						Commands->Attach_Script(o2,script,params);
 					}
 				}
 			}
@@ -222,17 +249,22 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			const DefinitionClass *d = Get_Definition(o);
+			const DefinitionClass *d = &o2->Get_Definition();
 			if (d->Get_Class_ID() == type)
 			{
-				if ((Get_Object_Type(o) == team) || (team == 2))
+				if ((Get_Object_Type(o2) == team) || (team == 2))
 				{
-					if (!Is_Script_Attached(o,script))
+					if (!Is_Script_Attached(o2,script))
 					{
-						Commands->Attach_Script(o,script,params);
+						Commands->Attach_Script(o2,script,params);
 					}
 				}
 			}
@@ -243,15 +275,10 @@
 
 SCRIPTS_API void Attach_Script_Player_Once(const char *script,const char *params,int team)
 {
-	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
-		{
-			const DefinitionClass *d = Get_Definition(o);
-			if (d->Get_Class_ID() == CID_Soldier)
-			{
+		SoldierGameObj *o = x->Data();
 				if ((Get_Object_Type(o) == team) || (team == 2))
 				{
 					if (!Is_Script_Attached(o,script))
@@ -259,8 +286,6 @@
 						Commands->Attach_Script(o,script,params);
 					}
 				}
-			}
-		}
 		x = x->Next();
 	}
 }
@@ -271,7 +296,7 @@
 	while (x)
 	{
 		GameObject *o = x->Data();
-		if ((o) && As_BuildingGameObj(o))
+		if (o)
 		{
 			if ((Get_Object_Type(o) == team) || (team == 2))
 			{
@@ -284,11 +309,11 @@
 
 SCRIPTS_API void Attach_Script_Is_Preset(GameObject *obj,const char *preset,const char *script,const char *params,int team)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	const DefinitionClass *d = Get_Definition(obj);
+	const DefinitionClass *d = &obj->Get_Definition();
 	if (!_stricmp(d->Get_Name(),preset))
 	{
 		if ((Get_Object_Type(obj) == team) || (team == 2))
@@ -300,11 +325,11 @@
 
 SCRIPTS_API void Attach_Script_Is_Type(GameObject *obj,unsigned long type,const char *script,const char *params,int team)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	const DefinitionClass *d = Get_Definition(obj);
+	const DefinitionClass *d = &obj->Get_Definition();
 	if (d->Get_Class_ID() == type)
 	{
 		if ((Get_Object_Type(obj) == team) || (team == 2))
@@ -319,7 +344,7 @@
 	SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_BuildingGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if (Get_Object_Type(o) == Team || Team == 2)
@@ -340,13 +365,11 @@
 
 SCRIPTS_API void Attach_Script_All_Turrets_Team(int Team,const char *Script,const char *Params,bool Once)
 {
-	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
+	SLNode<VehicleGameObj> *x = GameObjManager::VehicleGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o) && As_VehicleGameObj(o))
-		{
-			if (Is_DecorationPhys(o) && (Get_Object_Type(o) == Team || Team == 2))
+		VehicleGameObj *o = x->Data();
+		if (Get_Vehicle_Mode(o) == VEHICLE_TYPE_TURRET && (Get_Object_Type(o) == Team || Team == 2))
 			{
 				if (Once)
 				{
@@ -357,7 +380,6 @@
 					Commands->Attach_Script(o,Script,Params);
 				}
 			}
-		}
 		x = x->Next();
 	}
 }
@@ -385,12 +407,17 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if (Is_Script_Attached(o, script))
+			if (Is_Script_Attached(o2, script))
 			{
-				return o;
+				return o2;
 			}
 		}
 		x = x->Next();
@@ -405,16 +432,21 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if (Is_Script_Attached(o, script))
+			if (Is_Script_Attached(o2, script))
 			{
-				float dist = Commands->Get_Distance(Commands->Get_Position(o),pos);
+				float dist = Commands->Get_Distance(Commands->Get_Position(o2),pos);
 				if (closest == NULL || dist < closestdist)
 				{
 					closestdist = dist;
-					closest = o;
+					closest = o2;
 				}
 			}
 		}
@@ -430,12 +462,17 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
 		{
-			if (Is_Script_Attached(o, script))
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 			{
-				objects.Add_Tail(o);
+			if (Is_Script_Attached(o2, script))
+			{
+				objects.Add_Tail(o2);
 			}
 		}
 		x = x->Next();
@@ -444,20 +481,25 @@
 
 SCRIPTS_API void Send_Custom_Event_To_Objects_With_Script( GameObject *sender, const char *script, int message, int param, float delay )
 {
-	if (!sender || !Commands->Get_ID(sender) )
+	if (!sender)
 	{
 		return;
 	}
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if ( Is_Script_Attached( o, script )
-				&& Commands->Get_ID ( sender ) != Commands->Get_ID ( o ) )
+			if ( Is_Script_Attached( o2, script )
+				&& Commands->Get_ID ( sender ) != Commands->Get_ID ( o2 ) )
 			{
-				Commands->Send_Custom_Event(sender,o,message,param,delay);
+				Commands->Send_Custom_Event(sender,o2,message,param,delay);
 			}
 		}
 		x = x->Next();
@@ -466,21 +508,26 @@
 
 SCRIPTS_API void Send_Custom_Event_To_Objects_With_Script_Ranged( GameObject *sender, const char *script, int message, int param, float delay, float range )
 {
-	if (!sender || !Commands->Get_ID(sender) )
+	if (!sender)
 	{
 		return;
 	}
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if ( Is_Script_Attached( o, script )
-				&& Commands->Get_ID ( sender ) != Commands->Get_ID ( o )
-				&& Commands->Get_Distance ( Commands->Get_Position ( sender ), Commands->Get_Position ( o ) ) <= range )
+			if ( Is_Script_Attached( o2, script )
+				&& Commands->Get_ID ( sender ) != Commands->Get_ID ( o2 )
+				&& Commands->Get_Distance ( Commands->Get_Position ( sender ), Commands->Get_Position ( o2 ) ) <= range )
 			{
-				Commands->Send_Custom_Event(sender,o,message,param,delay);
+				Commands->Send_Custom_Event(sender,o2,message,param,delay);
 			}
 		}
 		x = x->Next();
@@ -489,14 +536,11 @@
 
 SCRIPTS_API ScriptImpClass* Find_Script_On_Object(GameObject* obj, const char *script)
 {
-	if (!obj || !Commands->Get_ID(obj) )
+	if (!obj)
 	{
 		return NULL;
 	}
-
-	if ( As_ScriptableGameObj(obj) )
-	{
-		const SimpleDynVecClass<GameObjObserverClass *> *observers = &((ScriptableGameObj *)obj)->Get_Observers();
+	const SimpleDynVecClass<GameObjObserverClass *> *observers = &obj->Get_Observers();
 		int x = observers->Count();
 		for (int i = 0;i < x;i++)
 		{
@@ -505,7 +549,23 @@
 				return ((ScriptImpClass*)(*observers)[i]);
 			}
 		}
-	}
 
 	return NULL;
 }
+
+void SCRIPTS_API Attach_Script_Occupants(GameObject *obj,const char *script,const char *params)
+{
+	if (!obj || !obj->As_VehicleGameObj())
+	{
+		return;
+	}
+	VehicleGameObj *o = obj->As_VehicleGameObj();
+	int x = o->Get_Definition().Get_Seat_Count();
+	for (int i = 0;i < x;i++)
+	{
+		if (o->Get_Occupant(i))
+		{
+			Commands->Attach_Script(o->Get_Occupant(i),script,params);
+		}
+	}
+}
diff -uwr sourceold/scripts/engine_script.h source/scripts/engine_script.h
--- sourceold/scripts/engine_script.h	2011-10-11 21:53:56.809570300 +0800
+++ source/scripts/engine_script.h	2012-04-24 15:57:17.879882800 +0800
@@ -38,4 +38,5 @@
 SCRIPTS_API void Send_Custom_Event_To_Objects_With_Script( GameObject *sender, const char *script, int message, int param, float delay ); // Script to send a custom to all objects with a specific script
 SCRIPTS_API void Send_Custom_Event_To_Objects_With_Script_Ranged( GameObject *sender, const char *script, int message, int param, float delay, float range ); // Script to send a custom to all objects with a specific script in a specified range
 SCRIPTS_API ScriptImpClass* Find_Script_On_Object(GameObject* obj, const char *script); // Returns a pointer to the first instance of the named script on the given object, or NULL if not found
+SCRIPTS_API void Attach_Script_Occupants(GameObject *obj,const char *script,const char *params); //attaches a script to all occupants of a vehicle
 #endif
diff -uwr sourceold/scripts/engine_tdb.cpp source/scripts/engine_tdb.cpp
--- sourceold/scripts/engine_tdb.cpp	2011-10-11 23:03:14.446289000 +0800
+++ source/scripts/engine_tdb.cpp	2012-04-24 12:13:24.675781200 +0800
@@ -61,31 +61,36 @@
 
 SCRIPTS_API const char *Get_Translated_Preset_Name(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return newstr("");
 	}
-	GameObject *o = As_DamageableGameObj(obj);
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return newstr("");
 	}
-	DamageableGameObjDef *d = (DamageableGameObjDef *)Get_Definition(obj);
+	const DamageableGameObjDef *d = &o->Get_Definition();
 	return Get_Translated_String(d->Get_Translated_Name_ID());
 }
 
 SCRIPTS_API const wchar_t *Get_Current_Wide_Translated_Weapon(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	GameObject *o = As_ArmedGameObj(obj);
+	PhysicalGameObj *o = obj->As_PhysicalGameObj();
 	if (!o)
 	{
 		return 0;
 	}
-	WeaponBagClass *w = ((ArmedGameObj *)o)->Get_Weapon_Bag();
+	ArmedGameObj *o2 = o->As_ArmedGameObj();
+	if (!o2)
+	{
+		return 0;
+	}
+	WeaponBagClass *w = o2->Get_Weapon_Bag();
 	if ((w->Get_Index()) && (w->Get_Index() < w->Get_Count()))
 	{
 		return Get_Wide_Translated_String(w->Peek_Weapon(w->Get_Index())->Get_Definition()->IconNameID);
@@ -100,21 +105,26 @@
 
 SCRIPTS_API const char *Get_Translated_Weapon(GameObject *obj,int position)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return newstr("");
 	}
-	GameObject *o = As_ArmedGameObj(obj);
+	PhysicalGameObj *o = obj->As_PhysicalGameObj();
 	if (!o)
 	{
 		return newstr("");
 	}
-	WeaponBagClass *w = ((ArmedGameObj *)o)->Get_Weapon_Bag();
+	ArmedGameObj *o2 = o->As_ArmedGameObj();
+	if (!o2)
+	{
+		return newstr("");
+	}
+	WeaponBagClass *w = o2->Get_Weapon_Bag();
 	if ((position) && (position < w->Get_Count()))
 	{
 		return Get_Translated_String(w->Peek_Weapon(position)->Get_Definition()->IconNameID);
 	}
-	return newstr("No String");
+	return newstr("");
 }
 
 SCRIPTS_API const char *Get_Team_Name(int Team)
@@ -132,11 +142,11 @@
 
 SCRIPTS_API const wchar_t *Get_Wide_Vehicle_Name(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return L"Vehicle";
 	}
-	VehicleGameObj *o = (VehicleGameObj *)As_VehicleGameObj(obj);
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	if (!o)
 	{
 		return L"Vehicle";
diff -uwr sourceold/scripts/engine_tt.cpp source/scripts/engine_tt.cpp
--- sourceold/scripts/engine_tt.cpp	2012-02-27 12:46:32.940882800 +0800
+++ source/scripts/engine_tt.cpp	2012-05-28 21:47:07.366210900 +0800
@@ -29,6 +29,9 @@
 #include "VehicleFactoryGameObjDef.h"
 #include "AirFactoryGameObj.h"
 #include "Iterator.h"
+#include "NavalFactoryGameObj.h"
+#include "SCAnnouncement.h"
+#include "cScTextObj.h"
 class WideStringClass;
 
 
@@ -68,6 +71,7 @@
 SCRIPTS_API ahh AddHostHook;
 SCRIPTS_API arh AddRefillHook;
 SCRIPTS_API allh AddLoadLevelHook;
+SCRIPTS_API allh AddPreLoadLevelHook;
 SCRIPTS_API allh AddGameOverHook;
 SCRIPTS_API allh AddThinkHook;
 SCRIPTS_API apjh AddPlayerJoinHook;
@@ -94,6 +98,8 @@
 SCRIPTS_API gvl Get_Vehicle_Limit;
 SCRIPTS_API svl Set_Air_Vehicle_Limit;
 SCRIPTS_API gvl Get_Air_Vehicle_Limit;
+SCRIPTS_API svl Set_Naval_Vehicle_Limit;
+SCRIPTS_API gvl Get_Naval_Vehicle_Limit;
 SCRIPTS_API sm Send_Message;
 SCRIPTS_API smp Send_Message_Player;
 SCRIPTS_API sw Set_Wireframe_Mode;
@@ -118,6 +124,8 @@
 SCRIPTS_API geo GetExplosionObj;
 SCRIPTS_API seo SetExplosionObj;
 SCRIPTS_API uno Update_Network_Object;
+SCRIPTS_API sct Send_Client_Text;
+SCRIPTS_API sca Send_Client_Announcement;
 SCRIPTS_API dod Do_Objectives_Dlg;
 SCRIPTS_API sl Set_Player_Limit;
 SCRIPTS_API gl Get_Player_Limit;
@@ -155,8 +163,11 @@
 SCRIPTS_API gtc Get_Team_Credits;
 SCRIPTS_API addConnectionAcceptanceFilterType addConnectionAcceptanceFilter;
 SCRIPTS_API removeConnectionAcceptanceFilterType removeConnectionAcceptanceFilter;
+SCRIPTS_API iwu Is_WOL_User;
 SCRIPTS_API ec Evict_Client;
 SCRIPTS_API gcsh Get_Client_Serial_Hash;
+SCRIPTS_API gml Get_Tech_Level;
+SCRIPTS_API sw Set_Tech_Level;
 
 SCRIPTS_API bool Can_Team_Build_Vehicle(int Team)
 {
@@ -188,10 +199,10 @@
 
 SCRIPTS_API void Send_Message_Team(int team,unsigned int red,unsigned int green,unsigned int blue,const char *msg)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == team) || (team == 2))
@@ -205,10 +216,10 @@
 
 SCRIPTS_API void Set_Obj_Radar_Blip_Shape_Team(int Team,GameObject *obj,int shape)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == Team) || (Team == 2))
@@ -222,10 +233,10 @@
 
 SCRIPTS_API void Set_Obj_Radar_Blip_Color_Team(int Team,GameObject *obj,int color)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == Team) || (Team == 2))
@@ -239,15 +250,15 @@
 
 SCRIPTS_API void Set_Occupants_Fade(GameObject *obj,float red,float green,float blue,float opacity)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	if (!As_VehicleGameObj(obj))
+	if (!obj->As_VehicleGameObj())
 	{
 		return;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	int x = o->Get_Definition().Get_Seat_Count();
 	for (int i = 0;i < x;i++)
 	{
@@ -261,10 +272,10 @@
 
 SCRIPTS_API void Enable_Team_Radar(int Team,bool Enable)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == Team) || (Team == 2))
@@ -278,14 +289,14 @@
 
 SCRIPTS_API void Create_Sound_Team(const char *soundname,const Vector3 & position,GameObject *obj,int team)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == team) || (team == 2))
@@ -299,10 +310,10 @@
 
 SCRIPTS_API void Create_2D_Sound_Team(const char *soundname,int team)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == team) || (team == 2))
@@ -316,10 +327,10 @@
 
 SCRIPTS_API void Create_2D_WAV_Sound_Team(const char *soundname,int team)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == team) || (team == 2))
@@ -333,14 +344,14 @@
 
 SCRIPTS_API void Create_3D_WAV_Sound_At_Bone_Team(const char *soundname,GameObject *obj,const char *bonename,int team)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == team) || (team == 2))
@@ -354,14 +365,14 @@
 
 SCRIPTS_API void Create_3D_Sound_At_Bone_Team(const char *soundname,GameObject *obj,const char *bonename,int team)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_SmartGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == team) || (team == 2))
@@ -820,27 +831,9 @@
 	Set_Special_Base_Destruction();
 }
 
-bool Vehicle_Preset_Is_Air(int preset)
-{
-	DefinitionClass *def = Find_Definition(preset);
-	if (!def)
-	{
-		return false;
-	}
-	if (def->Get_Class_ID() == 12304)
-	{
-		VehicleGameObjDef *def2 = (VehicleGameObjDef *)def;
-		if (def2->Get_Type() == VEHICLE_TYPE_FLYING)
-		{
-			return true;
-		}
-	}
-	return false;
-}
-
 bool SCRIPTS_API Create_Vehicle(const char *Preset_Name,float Delay,GameObject *Owner,int Team)
 {
-	if (Get_Vehicle(Owner))
+	if (Owner && Get_Vehicle(Owner))
 	{
 		return false;
 	}
@@ -857,27 +850,27 @@
 	{
 		vf = bg2->As_VehicleFactoryGameObj();
 	}
-	if (!vf && !Vehicle_Preset_Is_Air(preset))
+	if (!vf && !Vehicle_Preset_Is_Air(preset) && !Vehicle_Preset_Is_Naval(preset))
 	{
 		return false;
 	}
-	if (vf && ((vf->Is_Destroyed()) || (vf->Is_Busy())))
+	if (vf && ((!vf->Is_Available())))
 	{
-		if ((!Vehicle_Preset_Is_Air(preset)) || (!vf->Get_Definition().Get_Build_Ground_Only()))
+		if (((!Vehicle_Preset_Is_Air(preset)) || (!vf->Get_Definition().Get_Build_Ground_Only())) && !Vehicle_Preset_Is_Naval(preset))
 		{
 			return false;
 		}
 	}
-	if (vf && (!Vehicle_Preset_Is_Air(preset) || !vf->Get_Definition().Get_Build_Ground_Only()))
+	if (vf && (!Vehicle_Preset_Is_Air(preset) || !vf->Get_Definition().Get_Build_Ground_Only()) && !Vehicle_Preset_Is_Naval(preset))
 	{
 		float delay = 5.0;
 		if (!base->Is_Base_Powered())
 		{
 			delay *= Get_Build_Time_Multiplier(Team);
 		}
-		vf->Request_Vehicle(preset,delay,Owner->As_SoldierGameObj());
+		vf->Request_Vehicle(preset,delay,Owner ? Owner->As_SoldierGameObj() : 0);
 	}
-	else
+	else if (Vehicle_Preset_Is_Air(preset))
 	{
 		BuildingGameObj *bg = ((BuildingGameObj *)base->Find_Building(BuildingConstants::TYPE_HELIPAD));
 		AirFactoryGameObj *af = 0;
@@ -885,15 +878,32 @@
 		{
 			af = bg->As_AirFactoryGameObj();
 		}
-		if (af && !af->Is_Destroyed() && !af->Is_Busy() && Vehicle_Preset_Is_Air(preset))
+		if (af && af->Is_Available() && Vehicle_Preset_Is_Air(preset))
 		{
-			af->Create_Vehicle(preset,Owner->As_SoldierGameObj());
+			af->Create_Vehicle(preset,Owner ? Owner->As_SoldierGameObj() : 0);
 		}
 		else
 		{
 			return false;
 		}
 	}
+	else
+	{
+		BuildingGameObj *bg = ((BuildingGameObj *)base->Find_Building(BuildingConstants::TYPE_NAVAL_FACTORY));
+		NavalFactoryGameObj *af = 0;
+		if (bg)
+		{
+			af = bg->As_NavalFactoryGameObj();
+		}
+		if (!af || !af->Is_Available() || !af->Can_Spawn(preset) || !Vehicle_Preset_Is_Naval(preset))
+		{
+			return false;
+		}
+		else
+		{
+			af->Create_Vehicle(preset,Owner ? Owner->As_SoldierGameObj() : 0);
+		}
+	}
 	return true;
 }
 
@@ -909,10 +919,39 @@
 		{
 			if (strcmp(fname,name) == 0)
 			{
-				ConsoleFunctionList.Delete(consoleFunction);
+				ConsoleFunctionList.DeleteObj(*consoleFunction);
+			}
+		}
+	}
+}
+
+SCRIPTS_API void cScTextObj::Set_Dirty_Bit_For_Team(DIRTY_BIT value, int teamId)
+{
+	TT_FOREACH(player, *Get_Player_List())
+	{
+		if (player->IsActive && player->PlayerType == teamId)
+			Set_Object_Dirty_Bit(player->PlayerId, value, true);
+	}
+}
+
+SCRIPTS_API void cNetEvent::Set_Object_Dirty_Bit_For_Version(float version,DIRTY_BIT dirty_bit, bool onoff)
+{
+	for (int clientId = 1; clientId < 128; ++clientId)
+	{
+		if (Get_Client_Version(clientId) >= version)
+		{
+			Set_Object_Dirty_Bit(clientId,dirty_bit,onoff);
 			}
 		}
 	}
+
+SCRIPTS_API void SCAnnouncement::Set_Dirty_Bit_For_Team(DIRTY_BIT value, int teamId)
+{
+	TT_FOREACH(player, *Get_Player_List())
+	{
+		if (player->IsActive && player->PlayerType == teamId)
+			Set_Object_Dirty_Bit(player->PlayerId, value, true);
+	}
 }
 
 RENEGADE_FUNCTION
@@ -922,3 +961,7 @@
 RENEGADE_FUNCTION
 SCRIPTS_API void Verbose_Help_File()
 AT2(0x004284F0,0x00428670);
+
+RENEGADE_FUNCTION
+SCRIPTS_API void ScriptableGameObj::Add_Observer( GameObjObserverClass * observer )
+AT2(0x006B6C70,0x006B6510);
diff -uwr sourceold/scripts/engine_tt.h source/scripts/engine_tt.h
--- sourceold/scripts/engine_tt.h	2012-02-27 12:46:32.867640600 +0800
+++ source/scripts/engine_tt.h	2012-05-28 21:47:07.505859300 +0800
@@ -21,7 +21,8 @@
 #include "cPlayer.h"
 class ConnectionAcceptanceFilter;
 class WideStringClass;
-
+class cScTextObj;
+class SCAnnouncement;
 //start per-player script commands stuff
 typedef void (*_Enable_Stealth_Player) (GameObject *obj,GameObject *obj2,bool enable);
 typedef void (*_Set_Fog_Enable_Player) (GameObject *obj,bool enable);
@@ -133,6 +134,9 @@
 typedef void (*ggd) (HashTemplateClass<StringClass, GameDefinition> &definitions);
 typedef SList<cPlayer> *(*gpl) ();
 typedef void (*uno) (NetworkObjectClass *obj);
+typedef cScTextObj *(*sct) (const WideStringClass& message, TextMessageEnum type, bool popup, int senderId, int receiverId, bool dodirtybit, bool doact);
+typedef SCAnnouncement *(*sca) (int _receiptientId, int _senderId, int _translationId, AnnouncementEnum _type, int _emoticonId, bool dodirtybit, bool doact);
+typedef bool (*iwu) (wchar_t *WideName);
 SCRIPTS_API extern gpl Get_Player_List;
 SCRIPTS_API extern gcmi Get_Current_Map_Index;
 SCRIPTS_API extern gm Get_Map;
@@ -165,6 +169,7 @@
 SCRIPTS_API extern rkh RemoveKeyHook;
 SCRIPTS_API extern gcmt GetCurrentMusicTrack;
 SCRIPTS_API extern allh AddLoadLevelHook;
+SCRIPTS_API extern allh AddPreLoadLevelHook;
 SCRIPTS_API extern allh AddGameOverHook;
 SCRIPTS_API extern allh AddThinkHook;
 SCRIPTS_API extern apjh AddPlayerJoinHook;
@@ -210,6 +215,8 @@
 SCRIPTS_API extern gvl Get_Vehicle_Limit;
 SCRIPTS_API extern svl Set_Air_Vehicle_Limit;
 SCRIPTS_API extern gvl Get_Air_Vehicle_Limit;
+SCRIPTS_API extern svl Set_Naval_Vehicle_Limit;
+SCRIPTS_API extern gvl Get_Naval_Vehicle_Limit;
 SCRIPTS_API extern sm Send_Message;
 SCRIPTS_API extern smp Send_Message_Player;
 SCRIPTS_API extern sw Set_Wireframe_Mode;
@@ -234,6 +241,8 @@
 SCRIPTS_API extern geo GetExplosionObj;
 SCRIPTS_API extern seo SetExplosionObj;
 SCRIPTS_API extern uno Update_Network_Object;
+SCRIPTS_API extern sct Send_Client_Text;
+SCRIPTS_API extern sca Send_Client_Announcement;
 SCRIPTS_API extern dod Do_Objectives_Dlg;
 SCRIPTS_API extern sl Set_Player_Limit;
 SCRIPTS_API extern gl Get_Player_Limit;
@@ -259,6 +268,9 @@
 SCRIPTS_API extern gdw Get_Damage_Warhead;
 SCRIPTS_API extern addConnectionAcceptanceFilterType addConnectionAcceptanceFilter;
 SCRIPTS_API extern removeConnectionAcceptanceFilterType removeConnectionAcceptanceFilter;
+SCRIPTS_API extern iwu Is_WOL_User;
+SCRIPTS_API extern gml Get_Tech_Level;
+SCRIPTS_API extern sw Set_Tech_Level;
 
 class SCRIPTS_API JFW_Key_Hook_Base : public ScriptImpClass {
 public:
diff -uwr sourceold/scripts/engine_ttdef.h source/scripts/engine_ttdef.h
--- sourceold/scripts/engine_ttdef.h	2012-02-18 09:50:34.036132800 +0800
+++ source/scripts/engine_ttdef.h	2012-04-14 04:09:47.176757800 +0800
@@ -24,6 +24,12 @@
 	TEXT_MESSAGE_PRIVATE,
 	TEXT_MESSAGE_TMSG, //special extra value for the TMSG console command
 };
+enum AnnouncementEnum
+{
+	ANNOUNCE_PUBLIC,
+	ANNOUNCE_TEAM,
+	ANNOUNCE_PRIVATE,
+};
 typedef bool (*ChatHook) (int PlayerID,TextMessageEnum Type,const wchar_t *Message,int recieverID);
 typedef bool (*HostHook) (int PlayerID,TextMessageEnum Type,const char *Message);
 typedef void (*ObjectCreateHook) (void *data,GameObject *obj);
@@ -34,7 +40,7 @@
 typedef int (*PurchaseHook) (BaseControllerClass *base,GameObject *purchaser,unsigned int cost,unsigned int preset,const char *data);
 typedef void (*PurchaseMonHook) (BaseControllerClass *base,GameObject *purchaser,unsigned int cost,unsigned int preset,unsigned int purchaseret,const char *data);
 typedef bool (*RefillHook) (GameObject *purchaser);
-typedef bool (*RadioHook) (int PlayerType, int PlayerID, int AnnouncementID, int IconID, uint8 AnnouncementType);
+typedef bool (*RadioHook) (int PlayerType, int PlayerID, int AnnouncementID, int IconID, AnnouncementEnum AnnouncementType);
 typedef bool (*StockDamageHook) (PhysicalGameObj* damager, PhysicalGameObj* target, float damage, uint warheadId);
 typedef bool (*TtDamageHook) (PhysicalGameObj* damager, PhysicalGameObj* target, const AmmoDefinitionClass* ammo, const char* bone);
 
